/*****************************************************************************
 * This is an illustration the uniformness of accessing container elements 
 * with iterators. By changing the typedef for sequence, you can store the
 * divisors and non-divisors in vectors or lists without changing the code.
 ****************************************************************************/
#include <iostream>
#include <vector>
#include <list>
using std::cin; using std::cout;            
using std::endl;            
using std::vector; using std::list;
//typedef vector<int> sequence;
typedef list<int> sequence;
void show_vec(const sequence& v);

int main()
{
	sequence V, div;
	int num;
	for(int i=1; i!=21; i++)
		V.push_back(i);//Load the sequence with values 1-20
	cout<<"Enter an integer. The program will sort the values 1-20"
	       <<" into values that  divide that integer evenly and "
      	       <<"values that do not.\nYour integer :";
	cin>>num;
	sequence::iterator iter=V.begin();//This cannot be a const iterator
					     // because we plan to use it to 
					     // modify  V.
	while(iter!=V.end())
	{
		if(num%*iter==0){
			div.push_back(*iter);//Push the value into the divisor
					    //sequence.
			iter=V.erase(iter);//Erase it from the original. The
				           //erase function returns an iterator
					   //indicating the next value. 
					     
		}
		else
			++iter;
	}
	cout<<"The values that divide "<<num<<" are\n";
	show_vec(div);
	cout<<endl<<"The values that do not divide "<<num<<" are\n";
	show_vec(V);
	return 0;
			
}
void show_vec(const sequence& v)
{
	for(sequence::const_iterator iter=v.begin(); iter!=v.end();++iter)
		cout<<*iter<<" ";
	/* We need a const iterator here because we passed v by constant 
	 * reference.
	 */   
	return;
}
	
